## ros-foxy-rclcpp-lifecycle 2.4.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclcpp_lifecycle)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic -Wnon-virtual-dtor -Woverloaded-virtual)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcl_lifecycle REQUIRED)
find_package(rosidl_typesupport_cpp REQUIRED)
find_package(lifecycle_msgs REQUIRED)

### CPP High level library
add_library(rclcpp_lifecycle
  src/lifecycle_node.cpp
  src/node_interfaces/lifecycle_node_interface.cpp
  src/state.cpp
  src/transition.cpp
)
target_include_directories(${PROJECT_NAME}
  PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")
# specific order: dependents before dependencies
ament_target_dependencies(rclcpp_lifecycle
  "rclcpp"
  "rcl_lifecycle"
  "lifecycle_msgs"
  "rosidl_typesupport_cpp"
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(rclcpp_lifecycle PRIVATE "RCLCPP_LIFECYCLE_BUILDING_DLL")

install(TARGETS
  rclcpp_lifecycle EXPORT rclcpp_lifecycle
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  set(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS ${rclcpp_INCLUDE_DIRS})
  ament_lint_auto_find_test_dependencies()

  find_package(performance_test_fixture REQUIRED)

  add_performance_test(
    benchmark_lifecycle_client
    test/benchmark/benchmark_lifecycle_client.cpp)
  if(TARGET benchmark_lifecycle_client)
    target_link_libraries(benchmark_lifecycle_client ${PROJECT_NAME})
    ament_target_dependencies(benchmark_lifecycle_client rclcpp)
  endif()
  add_performance_test(
    benchmark_lifecycle_node
    test/benchmark/benchmark_lifecycle_node.cpp)
  if(TARGET benchmark_lifecycle_node)
    target_link_libraries(benchmark_lifecycle_node ${PROJECT_NAME})
    ament_target_dependencies(benchmark_lifecycle_node rclcpp)
  endif()
  add_performance_test(
    benchmark_state
    test/benchmark/benchmark_state.cpp)
  if(TARGET benchmark_state)
    target_link_libraries(benchmark_state ${PROJECT_NAME})
  endif()
  add_performance_test(
    benchmark_transition
    test/benchmark/benchmark_transition.cpp)
  if(TARGET benchmark_transition)
    target_link_libraries(benchmark_transition ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_lifecycle_node test/test_lifecycle_node.cpp)
  if(TARGET test_lifecycle_node)
    ament_target_dependencies(test_lifecycle_node
      "rcl_lifecycle"
      "rclcpp"
      "rcutils"
    )
    target_link_libraries(test_lifecycle_node ${PROJECT_NAME} mimick)
  endif()
  ament_add_gtest(test_lifecycle_publisher test/test_lifecycle_publisher.cpp)
  if(TARGET test_lifecycle_publisher)
    ament_target_dependencies(test_lifecycle_publisher
      "rcl_lifecycle"
      "rclcpp"
      "test_msgs"
    )
    target_link_libraries(test_lifecycle_publisher ${PROJECT_NAME})
  endif()
  ament_add_gtest(test_lifecycle_service_client test/test_lifecycle_service_client.cpp)
  if(TARGET test_lifecycle_service_client)
    ament_target_dependencies(test_lifecycle_service_client
      "rcl_lifecycle"
      "rclcpp"
      "rcutils"
    )
    target_link_libraries(test_lifecycle_service_client ${PROJECT_NAME} mimick)
  endif()
  ament_add_gtest(test_state_machine_info test/test_state_machine_info.cpp)
  if(TARGET test_state_machine_info)
    ament_target_dependencies(test_state_machine_info
      "rcl_lifecycle"
      "rclcpp"
    )
    target_link_libraries(test_state_machine_info ${PROJECT_NAME})
  endif()
  ament_add_gtest(test_register_custom_callbacks test/test_register_custom_callbacks.cpp)
  if(TARGET test_register_custom_callbacks)
    ament_target_dependencies(test_register_custom_callbacks
      "rcl_lifecycle"
      "rclcpp"
    )
    target_link_libraries(test_register_custom_callbacks ${PROJECT_NAME})
  endif()
  ament_add_gtest(test_callback_exceptions test/test_callback_exceptions.cpp)
  if(TARGET test_callback_exceptions)
    ament_target_dependencies(test_callback_exceptions
      "rcl_lifecycle"
      "rclcpp"
    )
    target_link_libraries(test_callback_exceptions ${PROJECT_NAME})
  endif()
  ament_add_gtest(test_state_wrapper test/test_state_wrapper.cpp)
  if(TARGET test_state_wrapper)
    ament_target_dependencies(test_state_wrapper
      "rcl_lifecycle"
      "rclcpp"
    )
    target_link_libraries(test_state_wrapper ${PROJECT_NAME})
  endif()
  ament_add_gtest(test_transition_wrapper test/test_transition_wrapper.cpp)
  if(TARGET test_transition_wrapper)
    ament_target_dependencies(test_transition_wrapper
      "rcl_lifecycle"
      "rclcpp"
      "rcutils"
    )
    target_link_libraries(test_transition_wrapper ${PROJECT_NAME} mimick)
    target_compile_definitions(test_transition_wrapper
      PUBLIC RCUTILS_ENABLE_FAULT_INJECTION
    )
  endif()
endif()

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(${PROJECT_NAME})
ament_export_dependencies(rclcpp)
ament_export_dependencies(rcl_lifecycle)
ament_export_dependencies(lifecycle_msgs)
ament_package()

install(DIRECTORY include/
  DESTINATION include)

=== debian/changelog ===
ros-foxy-rclcpp-lifecycle (2.4.3-1focal) focal; urgency=high



 -- Karsten Knese <karsten@osrfoundation.org>  Sat, 27 May 2023 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (2.4.2-1focal) focal; urgency=high



 -- Karsten Knese <karsten@osrfoundation.org>  Mon, 25 Jul 2022 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (2.4.1-1focal) focal; urgency=high



 -- Karsten Knese <karsten@osrfoundation.org>  Mon, 31 Jan 2022 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (2.4.0-1focal) focal; urgency=high

  * Fix SEGV caused by order of destruction of Node sub-interfaces (#1469 <https://github.com/ros2/rclcpp/issues/1469>) (#1736 <https://github.com/ros2/rclcpp/issues/1736>)
  * Contributors: Colin MacKenzie

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 01 Sep 2021 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (2.3.1-1focal) focal; urgency=high

  * Update quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#1616 <https://github.com/ros2/rclcpp/issues/1616>)
  * Contributors: Simon Honigmann

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 14 Apr 2021 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (2.3.0-1focal) focal; urgency=high

  * Reserve vector capacities and use emplace_back for constructing vectors (#1464 <https://github.com/ros2/rclcpp/issues/1464>) (#1489 <https://github.com/ros2/rclcpp/issues/1489>)
  * Change uint8_t iterator variables to size_t (#1461 <https://github.com/ros2/rclcpp/issues/1461>) (#1488 <https://github.com/ros2/rclcpp/issues/1488>)
  * Update QD to QL 1 (#1480 <https://github.com/ros2/rclcpp/issues/1480>)
  * Benchmark lifecycle features (#1462 <https://github.com/ros2/rclcpp/issues/1462>) (#1471 <https://github.com/ros2/rclcpp/issues/1471>)
  * Fix race in test_lifecycle_service_client (#1204 <https://github.com/ros2/rclcpp/issues/1204>)
  * Increase test coverage of rclcpp_lifecycle to 96% (#1298 <https://github.com/ros2/rclcpp/issues/1298>)
  * Add missing tests for rclcpp lifecycle (#1240 <https://github.com/ros2/rclcpp/issues/1240>)
  * Contributors: Alejandro Hernández Cordero, Dirk Thomas, Jacob Perron, Louise Poubel, Stephen Brawner

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 09 Dec 2020 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (2.2.0-1focal) focal; urgency=high

  * Log error instead of throwing exception in Transition and State reset() mark no except (#1297 <https://github.com/ros2/rclcpp/issues/1297>) (#1378 <https://github.com/ros2/rclcpp/issues/1378>)
  * Remove rmw-dependent unit-test checks (#1293 <https://github.com/ros2/rclcpp/issues/1293>) (#1377 <https://github.com/ros2/rclcpp/issues/1377>)
  * Contributors: Stephen Brawner

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 07 Oct 2020 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (2.1.0-1focal) focal; urgency=high

  * Warn about unused result of add_on_set_parameters_callback (#1238 <https://github.com/ros2/rclcpp/issues/1238>) (#1244 <https://github.com/ros2/rclcpp/issues/1244>)
  * Contributors: Jacob Perron

 -- Karsten Knese <karsten@osrfoundation.org>  Mon, 03 Aug 2020 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (2.0.2-1focal) focal; urgency=high



 -- Karsten Knese <karsten@osrfoundation.org>  Tue, 07 Jul 2020 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (2.0.1-1focal) focal; urgency=high

  * Fixed doxygen warnings (#1163 <https://github.com/ros2/rclcpp/issues/1163>) (#1191 <https://github.com/ros2/rclcpp/issues/1191>)
  * Contributors: Alejandro Hernández Cordero

 -- Karsten Knese <karsten@osrfoundation.org>  Tue, 23 Jun 2020 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (2.0.0-1focal) focal; urgency=high

  * Added missing virtual destructors. (#1149 <https://github.com/ros2/rclcpp/issues/1149>)
  * Add Security Vulnerability Policy pointing to REP-2006. (#1130 <https://github.com/ros2/rclcpp/issues/1130>)
  * Fixed ``test_lifecycle_node.cpp:check_parameters`` (#1136 <https://github.com/ros2/rclcpp/issues/1136>)
  * Contributors: Chris Lalancette, Ivan Santiago Paunovic

 -- Karsten Knese <karsten@osrfoundation.org>  Mon, 01 Jun 2020 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (1.1.0-1focal) focal; urgency=high

  * Deprecate set_on_parameters_set_callback (#1123 <https://github.com/ros2/rclcpp/issues/1123>)
  * Add missing parameter callback functions to lifecycle node (#1134 <https://github.com/ros2/rclcpp/issues/1134>)
  * Expose get_service_names_and_types_by_node from rcl in rclcpp (#1131 <https://github.com/ros2/rclcpp/issues/1131>)
  * Improve documentation (#1106 <https://github.com/ros2/rclcpp/issues/1106>)
  * Fixed rep links and added more details to dependencies in quality declaration (#1116 <https://github.com/ros2/rclcpp/issues/1116>)
  * Update quality declaration to reflect version 1.0 (#1115 <https://github.com/ros2/rclcpp/issues/1115>)
  * Contributors: Alejandro Hernández Cordero, Claire Wang, Dirk Thomas, Stephen Brawner

 -- Karsten Knese <karsten@osrfoundation.org>  Tue, 26 May 2020 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (1.0.0-1focal) focal; urgency=high

  * Avoid callback_group deprecation (#1108 <https://github.com/ros2/rclcpp/issues/1108>)
  * Contributors: Karsten Knese

 -- Karsten Knese <karsten@osrfoundation.org>  Tue, 12 May 2020 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (0.9.1-1focal) focal; urgency=high

  * Added rclcpp lifecycle Doxyfile (#1089 <https://github.com/ros2/rclcpp/issues/1089>)
  * Added Quality declaration: rclcpp, rclpp_action, rclcpp_components andrclcpp_lifecycle (#1100 <https://github.com/ros2/rclcpp/issues/1100>)
  * Increasing test coverage of rclcpp_lifecycle (#1045 <https://github.com/ros2/rclcpp/issues/1045>)
  * Contributors: Alejandro Hernández Cordero, brawner

 -- Karsten Knese <karsten@osrfoundation.org>  Fri, 08 May 2020 00:00:00 -0000

ros-foxy-rclcpp-lifecycle (0.9.0-1focal) focal; urgency=high

  * Export targets in addition to include directories / libraries (#1096 <https://github.com/ros2/rclcpp/issues/1096>)


=== debian/control ===
Source: ros-foxy-rclcpp-lifecycle
Section: misc
Priority: optional
Maintainer: Karsten Knese <karsten@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-ament-cmake-ros, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-lifecycle-msgs, ros-foxy-mimick-vendor <!nocheck>, ros-foxy-performance-test-fixture <!nocheck>, ros-foxy-rcl-lifecycle, ros-foxy-rclcpp, ros-foxy-rcutils <!nocheck>, ros-foxy-rmw, ros-foxy-rosidl-typesupport-cpp, ros-foxy-test-msgs <!nocheck>, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rclcpp-lifecycle
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-lifecycle-msgs, ros-foxy-rcl-lifecycle, ros-foxy-rclcpp, ros-foxy-rmw, ros-foxy-rosidl-typesupport-cpp, ros-foxy-ros-workspace
Description: Package containing a prototype for lifecycle implementation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rclcpp-lifecycle//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
